<?php
if(!defined('WIKI_PAPERS_PLUGIN')) die();
//$server_path = "";
//$wiki_path = "";
//$wiki_papers_path = DOKU_PLUGIN."wiki_papers/";
//$charts_path = $wiki_papers_path . "chart_img/";
//if (!is_dir($charts_path)) mkdir($charts_path, 0755);

//$tahoma = "lib/plugins/wiki_papers/Fonts/tahoma.ttf";
//$tahoma = $wiki_papers_path . "Fonts/tahoma.ttf";
//$tahoma = "Fonts/tahoma.ttf";

include( "pChart/pData.class");
include(WIKI_PAPERS_PLUGIN . "pChart/pChart.class");

function draw_text($table, $options){
	$text = "";
	$arr = array();
	$author = array();
	$str = array();
	$showauth = !in_array("HIDEAUTHOR", $options);
	foreach ($table as $table_key => $row){
		//$text .= "<p>";
		$arr[$table_key] = array();
		$author[$table_key] = "";
		foreach ($row as $col_n => $column){
			if ($column[0] != "author"){
				array_push($arr[$table_key], $column[1]);
				//foreach ($column as $column_key => $value) $text .= $value . " ";
				//$text .= $column[1] . " ";
			} else {
				$author[$table_key] = $column[1];
			}
		}
		$s = "";
		if ($showauth) $s .= $author[$table_key] . ": ";
		$s .= implode(", ", $arr[$table_key]);
		$str[$table_key] = $s;
		//$text .= "</p>";
	}
	$text = "<p>" . implode("<br/>", $str) . "</p>";
	return $text;
}

function print_row($table, $type="td"){
	$text .= "<tr>";
	foreach ($table as $hkey => $hval){
		$text .= "<" . $type . " class=\"col" . $hkey . " centeralign\">" . $hval . "</" . $type . ">";
	}
	$text .= "</tr>";
	return $text;
}

function draw_table($table, $options, $h_alt, $title){
	$text = "";
	$keys = array();
	$showauthor = !in_array("HIDEAUTHOR", $options);
	$h_a = is_array($h_alt);
	if (!in_array("NOHEADERS", $options)){ //headers are visible
		
		foreach ($table as $table_key => $row){
			foreach ($row as $col_n => $column){
				if (!in_array($column[0], $keys)){
					array_push($keys, $column[0]);
				}
			}
		}
		
		if ($title != "") {
			$colspan = count($keys);
			$text .= "<tr><th class=\"col0 centeralign\" colspan=\"$colspan\">$title</th></tr>";
		}
		
		$text .= print_row(($h_a) ? $h_alt : $keys, "th");
		
		foreach ($table as $table_key => $row){
			$text .= "<tr>";
			foreach ($keys as $keys_key => $key){
				$found = false;
				foreach ($row as $col_n => $column){
					if ($column[0] === $key){
						$text .= "<td class=\"col" . $keys_key . "\">" . $column[1] . "</td>";
						$found = true;
						break;
					}
				}
				if (!$found) $text .= "<td class=\"col" . $keys_key . "\">" . "&nbsp;" . "</td>";
			}
			$text .= "</tr>";
		}
	} else { // Defalult headers are not visible
		if ($title != "") {
			$colspan = count($table[0]);
			$text .= "<tr><th class=\"col0 centeralign\" colspan=\"$colspan\">$title</th></tr>";
		}
		if ($h_a){
			$text .= print_row($h_alt, "th");
		}
		foreach ($table as $table_key => $row){
			$text .= "<tr>";
			foreach ($row as $col_n => $column){
				if ($showauthor || $column[0] != "author"){
					//foreach ($column as $column_key => $value) $text .= "<td>$value</td>";
					$text .= "<td class=\"col" . $col_n . "\">" . $column[1] . "</td>";
				}
			}
			$text .= "</tr>";
		}
	}
	return "<table class=\"inline\"><tbody>$text</tbody></table>";
}

function draw_chart($table, $options, $match, $title){
	global $INFO;
	global $conf;
// 	$font = "lib/plugins/wiki_papers/Fonts/tahoma.ttf";
	$font = WIKI_PAPERS_PLUGIN . "Fonts/tahoma.ttf";
	if ($title == "") $title = "Publications";
	
	//$mediadir = (($conf["mediadir"] !== "/") ? $conf["mediadir"] : "") . "/".str_replace(":", "/", "wiki" . $INFO['namespace'] );
	$mediadir = $conf["mediadir"]."/".str_replace(":", "/",$INFO['namespace'] );
	if (!is_dir($mediadir)) mkdir($mediadir,0755);
	
	$md5 = md5($match);
// 	$charts_path = WIKI_PAPERS_PLUGIN . "chart_img/";
	//$charts_path = $mediadir . "wiki_papers_charts/";
	//if (!is_dir($charts_path)) mkdir($charts_path,0755);
	$filename = 'wiki_papers_chart_' . $md5 . '.png';
	$imagefile = $mediadir . '/' . $filename;
	$imageurl =  $INFO['namespace'] . ":" . $filename;
	

/*
	//$mediadir = (($conf["mediadir"] !== "/") ? $conf["mediadir"] : "") . "/".str_replace(":", "/", "wiki" . $INFO['namespace'] );

	//if (!is_dir($mediadir)) mkdir($mediadir, 0755);

	//$imagefile = (($mediadir !== "/") ? $mediadir : "") .'/wiki_papers_plugin' . '_' . $md5 . '.png';
	//$imagefile = $charts_path . $md5 . '.png';\
*/

	$DataSet = new pData;
	
	$keys = array();
	foreach ($table as $table_key => $row){
		foreach ($row as $col_n => $column){
			if ($column[0] !== "author" && !in_array($column[0], $keys)){
				array_push($keys, $column[0]);
			}
		}
	}
	
	$sn = 0;
	foreach ($table as $table_key => $row){
		$data = array();
		$author = $row[0][2];
		foreach ($keys as $keys_key => $key){
			$found = false;
			foreach ($row as $col_n => $column){
				if ($column[0] === $key){
					array_push($data, $column[2]);
					$found = true;
					break;
				}
			}
			if (!$found) array_push($data, 0);
		}
		$DataSet->AddPoint($data, "Serie$sn");
		$DataSet->SetSerieName($author, "Serie$sn");
		$sn ++;
	}
	
	$DataSet->AddPoint($keys, "keys");
	
	$DataSet->AddAllSeries();
	$DataSet->SetAbsciseLabelSerie("keys");
	
	$aun = count($table);
	$kn = count($keys);
	$n = $aun * $kn;
	
	$margin = 3;
	$barwidth = 25;
	if (in_array("EXTRASPAN", $options)) $margin += 25;
	
	$ml = 50;
	$mt = 30;
	$md = 30;
	$mr = 30;
	$x = $cml + $cmr + (($barwidth  + $margin) * $aun + 2*$barwidth) * $kn;
	$y = 240;
	
// Initialise the graph
	$chart = new pChart($x, $y);
	$chart->setFontProperties($font, 8);
	$chart->setGraphArea($ml, $mt, $x - $mr, $y - $md);
	$chart->drawFilledRoundedRectangle(2, 2, $x-2, $y-2, 5, 240, 240, 240);
	$chart->drawRoundedRectangle(0, 0, $x, $y, 5, 230, 230, 230);
	$chart->drawGraphArea(255,255,255,TRUE);
	$chart->drawScale($DataSet->GetData(),$DataSet->GetDataDescription(),SCALE_NORMAL,150,150,150,TRUE,0,2,TRUE);
	$chart->drawGrid(4,TRUE,230,230,230,50);

// Draw the 0 line
	$chart->setFontProperties($font,6);
	$chart->drawTreshold(0,143,55,72,TRUE,TRUE);
	
	$DataSet -> RemoveSerie("keys");

// Draw the bar graph
	$chart->drawBarGraph($DataSet->GetData(),$DataSet->GetDataDescription(),TRUE,80);
// Finish the graph
	$chart->setFontProperties($font,8);
	$chart->drawLegend($x - 5*$mr,$mt,$DataSet->GetDataDescription(),255,255,255);
	$chart->setFontProperties($font,10);
	$chart->drawTitle($ml*1.5, $mt *0.5, $title, 50, 50, 50);
	$chart->Render($imagefile);
	
	return $imageurl;
}
?>