<?php

if(!defined('WIKI_PAPERS_PLUGIN')) die();

function contains_str($str, $pattern){
	return preg_match("/$pattern/", $str);
}

function make_table($str, $left, $right, $pattern = ""){
	$table = array();
	$len = strlen($left) + strlen($right);
	while ($str != "" && $str !== false){
		if (!contains_str($str, $left)) break;
		$substr = get_string_between($str, $left, $right);
		if (!isset($substr) || $substr === "" || $substr === false) {}
		else if ($pattern == "" || preg_match("/$pattern/", $substr))
			array_push($table, $substr);
		$pos = strpos($str, $left);
		$str = substr($str, strlen($substr) + $pos + $len);
	}
	return $table;
}

function search_in($str, $left, $right, $pattern){
	//$str1 = $str;
	$result = 0;
	$len = strlen($left) + strlen($right);
	while ($str != "" && $str !== false){
		$substr = get_string_between($str, $left, $right);
		if (!isset($substr) || $substr === "" || $substr === false) break;
		if ($pattern == "" || preg_match("/$pattern/", $substr))
			$result ++;
		$pos = strpos($str, $left);
		$str = substr($str, strlen($substr) + $pos + $len);
	}
	return $result;
}

function get_string_between($string, $start, $end){
	$string = " ".$string;
	$ini = strpos($string, $start);
	if ($ini == 0) return "";
	$ini += strlen($start);
	$len = strpos($string, $end, $ini) - $ini;
	return substr($string, $ini, $len);
}

function cut_string_between(&$string, $start, $end){
	$ini = ($start === "") ? 0 : strpos($string, $start);
	if ($ini === false) return "";
	
	$startlng = strlen($start);
	$endlng = strlen($end);
	$endpos = ($endlng === 0) ? strlen($string) : strpos($string, $end, $ini + $startlng);
	
	if ($endpos === false) return "";
	$len = $endpos - $ini - $startlng;
	
	$subs = substr($string, $ini + $startlng, $len);
	$left = "";
	if ($ini > 1) $left = substr($string, 0, $ini);
	$right = substr($string, $endpos + $endlng);
	
	if ($right === false) $right = "";
	$string = $left . $right;
	
	return $subs;
}

function decompose_string_between($string, $start, $end, &$left, &$right){
	$ini = ($start === "") ? 0 : strpos($string, $start);
	if ($ini === false) return "";
	
	$startlng = strlen($start);
	$endlng = strlen($end);
	$endpos = ($endlng === 0) ? strlen($string) : strpos($string, $end, $ini + $startlng);
	
	if ($endpos === false) return "";
	$len = $endpos - $ini - $startlng;
	
	$subs = substr($string, $ini + $startlng, $len);
	$left = "";
	if ($ini > 1) $left = substr($string, 0, $ini);
	$right = substr($string, $endpos + $endlng);
	
	if ($right === false) $right = "";
	//$string = $left . $right;
	
	return $subs;
}

function split_string($string){

	$split = split(";", $string);
	
	$url = "";
	$year = "";
	$string = "";
	$to_year = null;
	
	foreach ($split as $key => $value){
		if (substr($value, 0, 7) == "http://"){
			$url = $value;
		} elseif (is_numeric($value[0])){
			list($year,$to_year) = split("-", $value);
			if(!is_numeric($year)) $year = 0;
			if(!is_numeric($to_year)) $to_year = null;
		} else {
			$string = $value;
		}
	}
	return array($string, $url, $year, $to_year);
}
?>